function mymodel = Kphaffii
%% Komagataella phaffii (Pichia pastoris) Central Carbon Metabolism
% The metabolic map and carbon transitions are taken from Wasylenko and
% Stephanopoulos (2015)(doi:10.1002/bit.25447).
% 
% Biomass equation was adapted for K. phaffii genome scale model iMT1026 
% according to Tomas-Gamisans et al. (2017)(doi:10.1111/1751-7915.12871).
%
% Methylotrophy was added according to general textbook knowledge, see e.g.
% Jorda et al. (2013)(doi:10.1186/1752-0509-7-17).


clear functions

r = reaction({...
...
... % Extracellular Fluxes	
...
    'Glc.ext (abcdef) -> G6P (abcdef)';... 
	'EtOH (ab) -> EtOH.ext (ab)';...
	'AcCOOH (ab) -> AcCOOH.ext (ab)';...
	'Glyc (abc) -> Glyc.ext (abc)';...
	'0.5023 Protein + 0.0649 RNA + 0.2724 Carbohydrates + 0.0018 DNA + 0.0197 Lipids -> Biomass';...    
...	
... % Pyruvate compartmentalization	
...
	'Pyr.c (abc) -> Pyr.mnt (abc)';...
	'Pyr.m (abc) -> Pyr.mnt (abc)';...
	'Pyr.mnt (abc) -> Pyr.fix (abc)';...
... 	
... % Glycolysis	
...
    'G6P (abcdef) <-> F6P (abcdef)';...
	'F6P (abcdef) <-> FBP (abcdef)';...
	'FBP (abcdef) <-> DHAP (cba) + G3P (def)';...
	'DHAP (abc) <-> G3P (abc)';...
	'G3P (abc) -> PG3 (abc)';...
	'PG3 (abc) -> PG2 (abc)';...
	'PG2 (abc) -> PEP (abc)';...
	'PEP (abc) -> Pyr.c (abc)';...
	'DHAP (abc) -> Glyc3P (abc)';...
	'Glyc3P (abc) -> Glyc (abc)';...
... 	
... % Pentose Phosphate Pathway	
...
	'G6P (abcdef) -> CO2 (a) + Ru5P (bcdef)';...
	'Ru5P (abcde) <-> R5P (abcde)';...
	'Ru5P (abcde) <-> X5P (abcde)';...
	'X5P (abcde) <-> G3P (cde) + TKC2 (ab)';...
	'F6P (abcdef) <-> E4P (cdef) + TKC2 (ab)';...
	'S7P (abcdefg) <-> R5P (cdefg) + TKC2 (ab)';...
	'F6P (abcdef) <-> G3P (def) + TAC3 (abc)';...
	'S7P (abcdefg) <-> E4P (defg) + TAC3 (abc)';...
... 	
... % Pyruvate metabolism	
...
	'Mal (abcd) -> Pyr.m (abc) + CO2 (d)';...
	'Pyr.c (abc) + CO2 (d) -> OAA.c (abcd)';...
	'Pyr.c (abc) -> AcCHO (bc) + CO2 (a)';...
	'AcCHO (ab) -> EtOH (ab)';...
	'AcCHO (ab) -> AcCOOH (ab)';...
	'AcCHO (ab) -> AcCoA.c (ab)';...
...
... % Citric Acid Cycle	
    'Pyr.m (abc) -> AcCoA.m (bc) + CO2 (a)';...
	'OAA.m (abcd) + AcCoA.m (ef) -> Cit (dcbfea)';...
	'Cit (abcdef) -> ICit (abcdef)';...
	'ICit (abcdef) -> AKG (abcde) + CO2 (f)';...
	'AKG (abcde) -> Suc (bcde) + CO2 (a)';...
	'Suc (abcd) <-> Fum (abcd)';...
	'Fum (abcd) <-> Mal (abcd)';...
	'Mal (abcd) <-> OAA.m (abcd)';...
...
... % One-carbon metabolism	
...
	'PG3 (abc) + Glu (defgh) -> Ser (abc) + AKG (defgh)';...
	'Ser (abc) <-> Gly (ab) + C1 (c)';...
	'Gly (ab) <-> CO2 (a) + C1 (b)';...
... 	
... % Transport across mitochondrial membrane	
...
	'Pyr.c (abc) -> Pyr.m (abc)';...
	'OAA.c (abcd) <-> OAA.m (abcd)';...
	'AcCoA.c (ab) <-> AcCoA.m (ab)';...
... 	
... % Amino Acid Biosynthesis	
...
	'AKG (abcde) -> Glu (abcde)';...
	'Glu (abcde) -> Gln (abcde)';...                                                                                                                     
	'Glu (abcde) -> Pro (abcde)';...              
	'Glu (abcde) + Glu (fghij) + CO2 (k) + Gln (lmnop) + Asp (qrst) -> AKG (abcde) + Arg (fghijk) + Glu (lmnop) + Fum (qrst)';... 
	'OAA.c (abcd) + Glu (efghi) -> Asp (abcd) + AKG (efghi)';... 
	'Asp (abcd) + Gln (efghi) -> Asn (abcd) + Glu (efghi)';...
	'Pyr.c (abc) + Glu (defgh) -> Ala (abc) + AKG (defgh)';...
 	'Pyr.m (abc) + Glu (defgh) -> Ala (abc) + AKG (defgh)';...
	'Asp (abcd) -> Thr (abcd)';...
	'Thr (abcd) -> Gly (ab) + AcCHO (cd)';... 
	'Ser (abc) + AcCoA.c (de) + Asp (fghi) + CO2(j) -> Cys (abc) + AcCOOH (de) + Suc (gihj) + CO2 (f)';... 
	'Asp (abcd) + C1 (e) + AcCoA.c (fg) -> Met (abcde) + AcCOOH (fg)';...
	'AKG (abcde) + AcCoA.c (fg) + Glu (hijkl) + Glu (mnopq) -> Lys (fgbcde) + CO2 (a) + AKG (hijkl) + AKG (mnopq)';...
	'AcCoA.m (ab) + Pyr.m (cde) + Pyr.m (fgh) + Glu (ijklm) -> Leu (abdghe) + CO2 (c) + CO2 (f) + AKG (ijklm)';...                                      
	'Thr (abcd) + Pyr.m (efg) + Glu (hijkl) -> Ile (abfcdg) + CO2 (e) + AKG (hijkl)';...                                                                      
	'Pyr.m (abc) + Pyr.m (def) + Glu (ghijk) -> Val (abecf) + CO2 (d) + AKG (ghijk)';...
	'PEP (abc) + PEP (def) + E4P (ghij) + Glu (klmno) -> Phe (abcefghij) + CO2 (d) + AKG (klmno)';...
	'PEP (abc) + PEP (def) + E4P (ghij) + Glu (klmno) -> Tyr (abcefghij) + CO2 (d) + AKG (klmno)';...
	'Ser (abc) + R5P (defgh) + PEP (ijk) + E4P (lmno) + PEP (pqr) + Gln (stuvw) -> Trp (abcedklmnoj) + CO2 (i) + G3P (fgh) + Pyr.c (pqr) + Glu (stuvw)';...
	'R5P (abcde) + C1 (f) + Gln (ghijk) + Asp (lmno) -> His (edcbaf) + AKG (ghijk) + Fum (lmno)';... 
...
... % Nucleotide Biosynthesis	
...
	'CO2 (b) + Asp (nfed) + R5P (vwxyz) + Gln (ijklm) ->  UMP (bdefvwxyz) + CO2 (n) + Glu (ijklm)';...
	'UMP (bdefvwxyz) + Gln (ijklm) -> CMP (bdefvwxyz) + Glu (ijklm)';... 
	'R5P (vwxyz) + Gln (ijklm) + Gln (nopqr) + Gly (de) + Asp (stua) + C1 (b) + C1 (h) + CO2 (f) -> IMP (bdefhvwxyz) + Glu (ijklm) + Glu (nopqr) + Fum (stua)';...
	'IMP (bdefhvwxyz) + Asp (ijkl) -> AMP (bdefhvwxyz) + Fum (ijkl)';...
	'IMP (bdefhvwxyz) + Gln (ijklm) -> GMP (bdefhvwxyz) + Glu (ijklm)';...
	'AMP (abcdefghij) -> DAMP (abcdefghij)';...
	'CMP (abcdefghi) -> DCMP (abcdefghi)';...
	'GMP (abcdefghij) -> DGMP (abcdefghij)';...
    'UMP (abcdefghi) -> DUMP (abcdefghi)';...
	'DUMP (abcdefghi) + C1 (j) -> DTMP (abcdjefghi)';...
... 	
... % Lipid Synthesis	
...
	'Glyc3P (abc) -> PA (abc)';...
	'Glyc3P (def) + Ser (abc) -> PS (abcdef)';...
	'Glyc3P (def) + Ser (abc) -> PE (cbdef) + CO2 (a)';...
	'Glyc3P (def) + Ser (abc) + C1 (g) + C1 (h) + C1 (i) -> PC (cbghidef) + CO2 (a)';...
	'Glyc3P (ghi) + G6P (abcdef) -> PI (fedcbaghi)';... 
	'Glyc3P (abc) -> TAG (abc)';...
	'AcCoA.c (ab) + AcCoA.c (cd) -> AcAcCoA (abcd)';...
	'AcAcCoA (abcd) + AcCoA.c (ef) -> HMGCoA (abcfed)';...
	'HMGCoA (abcdef) -> MVL (edcbaf)';...
	'MVL (abcdef) -> IPPP (edcbf) + CO2 (a)';...
	'IPPP (abcde) -> DMAPP (abcde)';...
	'DMAPP (abcde) + IPPP (fghij) + IPPP + DMAPP + IPPP + IPPP -> CO2 (d) + CO2 (e) + CO2 (j) + zymosterol';...
	'zymosterol + C1 -> ergosterol';... 
...
... % Carbohydrate Biosynthesis	
...
	'G6P (abcdef) + G6P (ghijkl) -> Trehalose (abcdefghijkl)';...
	'G6P (abcdef) -> Glycogen (abcdef)';...
	'G6P (abcdef) -> Glucan (abcdef)';...
	'F6P (abcdef) -> Mannan (abcdef)';...
...	
... % Transport	
...    
	'CO2.ext (a) -> CO2 (a)';...
 	'CO2 (a) -> CO2.out (a)';...   
...
... % MeOH-uptake and assimilation
... 
    'MeOH.per (a) -> FAld.per (a)' ;...
    'FAld.per (a) -> FOR.per (a)';...
    'X5P.per (abcde) + FAld.per (f) -> G3P.per (cde) + DHA.per (fab)';...
    'G3P.per (abc) <-> G3P (abc)';...
    'DHA.per (abc) <-> DHA (abc)';...
    'DHA (abc) -> DHAP (abc)';...
    'FOR.per (a) <-> FOR (a)';...
    'FOR (a) -> CO2 (a)';...
    'X5P (abcde) <-> X5P.per (abcde)';...
    'FOR (a) -> C1 (a)';...
    'MeOH.ext (a) -> MeOH.per (a)';...
...    
... % added biomass reactions according to iMT1026
...
    '0.6083 Gln + 0.6083 Glu + 0.0892 Met + 0.5668 Ser + 0.7674 Ala + 0.5356 Asp + 0.6344 Gly + 0.5356 Asn + 0.5053 Arg + 0.0810 Trp + 0.3099 Phe + 0.6194 Lys + 0.2376 Tyr + 0.5692 Thr + 0.0357 Cys + 0.6906 Leu + 0.2242 His + 0.5356 Val + 0.4001 Pro + 0.4333 Ile -> Protein';... 
    '0.8794 AMP + 0.7774 CMP + 0.7045 GMP + 0.7618 UMP -> RNA';...
    '0.9565 DAMP + 0.6674 DCMP + 0.6674 DGMP + 0.9565 DTMP -> DNA';...
    '0.0246 PA + 0.5066 PC + 0.3287 PE + 0.0617 PI + 0.0645 PS -> Phospholipids';...
    '0.8931 ergosterol + 0.0376 zymosterol -> Sterols';...
    '0.2051 Phospholipids + 0.4766 Sterols + 0.7272 TAG -> Lipids';...
    '1.769 Glycogen + 0.022 Trehalose + 1.03 Mannan + 3.065 Glucan -> Carbohydrates';...
    });

mymodel = model(r);

% Take care of symmetrical metabolites
mymodel.mets{'Suc'}.sym = list('rotate180',atommap('1:4 2:3 3:2 4:1'));
mymodel.mets{'Fum'}.sym = list('rotate180',atommap('1:4 2:3 3:2 4:1'));
mymodel.mets{'DHA'}.sym = list('rotate180',atommap('1:3 2:2 3:1'));

end